//+------------------------------------------------------------------+
//|                                                   ShadowTrader   |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                                                             v1.2 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double Lots     = 0.1;
extern int TakeProfit  =  500;
extern int StopLoss    =  500;
extern int limit       =   5; //    
extern int ProfitLevel =  30; //         

static int magicNumber = 23456;
static datetime prev_min = D'1.1.1'; //  
static datetime prev_max = D'1.1.1'; //  

bool AllowTrade,NewBar,OrdersClose,OpenSell,OpenBuy;
datetime LastTrade;
int ticket,n;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   AllowTrade=True;OrdersClose=false;OpenSell=false;OpenBuy=false;
   LastTrade=CurTime();
   ticket=0;n=0;
   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
if ((Year()<2005) || (Month()<7)) return (0);

double iFractals_up = 0; // 
double iFractals_lo = 0; // 
double TP =0,SL=0,price=0,totalprofit=0;
int cnt=0,i=0,totalcountpos=0;

   
//  
int ps=0,pb=0,ss=0,sb=0,ls=0,lb=0;
   

//+------------------------------------------------------------------------------------------------+
//|                                               
//+------------------------------------------------------------------------------------------------+
//     ,    
for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
{  
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       
   if (OrderType()==OP_SELL && OrderSymbol()==Symbol())
   {  //   
      ps=ps+1;totalcountpos=totalcountpos+1;
      totalprofit=totalprofit+OrderProfit();
   }
   if (OrderType()==OP_BUY  && OrderSymbol()==Symbol())
   {  //   
      pb=pb+1;totalcountpos=totalcountpos+1;
      totalprofit=totalprofit+OrderProfit();
   }
   if (OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol())
   {  //   SellStop
      ss=ss+1;totalcountpos=totalcountpos+1;
   }
   if (OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol())
   {  //   BuyStop
      sb=sb+1;totalcountpos=totalcountpos+1;
   }
} 
//+------------------------------------------------------------------------------------------------+
//|                                                
//+------------------------------------------------------------------------------------------------+

//+------------------------------------------------------------------------------------------------+
//|         ,                                                 
//+------------------------------------------------------------------------------------------------+
if (totalprofit>ProfitLevel)
{
AllowTrade=false;
OrdersClose=true;
}
//+------------------------------------------------------------------------------------------------+
//|                                               
//+------------------------------------------------------------------------------------------------+

//+------------------------------------------------------------------------------------------------+
//|                                               
//+------------------------------------------------------------------------------------------------+
if (OrdersClose)
{
AllowTrade=false;
bool result=false;

for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
{  
   if (((CurTime()-LastTrade)<10) || (LastTrade==0)) return (0);
   result=false;
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   RefreshRates();
   {
      if ((OrderSymbol()==Symbol()) && (OrderType()==OP_BUY))
      {
         result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),5,Yellow);  
         if (result){ LastTrade=CurTime();break; }
      }
      if ((OrderSymbol()==Symbol()) && (OrderType()==OP_SELL))
      {
         result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),5,Blue );  
         if (result){ LastTrade=CurTime();break; }
      }
      if ((OrderSymbol()==Symbol()) && (OrderType()==OP_BUYSTOP) && (OrderMagicNumber()== magicNumber))
      {
         result=OrderDelete(OrderTicket());  
         if (result){ LastTrade=CurTime();break; }
      }   
      if ((OrderSymbol()==Symbol()) && (OrderType()==OP_SELLSTOP) && (OrderMagicNumber()== magicNumber))
      {
         result=OrderDelete(OrderTicket());  
         if (result){ LastTrade=CurTime();break; }
      }   
   
   }
}

if(result==false)
{
   Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
   Sleep(3000);
}   
}
//+------------------------------------------------------------------------------------------------+
//|                                                
//+------------------------------------------------------------------------------------------------+

//+------------------------------------------------------------------------------------------------+
//|     ,  5                                             
//+------------------------------------------------------------------------------------------------+
if (totalcountpos==0)
{
    OrdersClose=false;
    Sleep(5000);
    AllowTrade=true;
}
//+------------------------------------------------------------------------------------------------+
//|                                          
//+------------------------------------------------------------------------------------------------+
   
//     ,  
if (AccountFreeMargin() < ((1000*Ask)*Lots)+100 ) 
{
Alert(" !");
return (0);
}
//+------------------------------------------------------------------------------------------------+
//|                                             
//+------------------------------------------------------------------------------------------------+
for (i = 0; i < 300; i++)   
{
   iFractals_up = iFractals(NULL, 0, MODE_UPPER, i);
   iFractals_lo = iFractals(NULL, 0, MODE_LOWER, i);
   if ((iFractals_up != 0) || (iFractals_lo != 0)) break;
}

//   ?
if ((iFractals_up != 0) && (Time[i] != prev_max) && (i < 3))
{
   OpenSell=true;prev_max = Time[i];
}
//   ?
if ((iFractals_lo != 0) && (Time[i] != prev_min) && (i < 3))
{ 
   OpenBuy=true;prev_min = Time[i];
}   
//+------------------------------------------------------------------------------------------------+
//|                                              
//+------------------------------------------------------------------------------------------------+

//+------------------------------------------------------------------------------------------------+
//|                                            
//+------------------------------------------------------------------------------------------------+
if (OpenSell && AllowTrade)
{
   if ((CurTime()-LastTrade)<10) return (0);
   ticket=0;
   //   .
   while (ticket==0)
   {
      RefreshRates();
      price = NormalizeDouble(High[i]+(limit*Point),Digits);
      SL    = price - StopLoss   * Point;
      TP    = price + TakeProfit * Point;      
      ticket=OrderSend(Symbol(), OP_BUYSTOP, Lots, price, 3, SL, TP, "OP_BUYSTOP", magicNumber, 0, Pink);
      Sleep(1000);
   }
   
   Sleep(10000);
      
   ticket=0;
   //   .
   while (ticket==0)
   {
      RefreshRates();
      SL = NormalizeDouble(Bid,Digits) + StopLoss   * Point;
      TP = NormalizeDouble(Bid,Digits) - TakeProfit * Point;
      ticket=OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),3,SL,TP,"OP_SELL",magicNumber,0,Blue);   
      Sleep(1000);
   }
   LastTrade=CurTime();
   OpenSell=false;
}

if (OpenBuy && AllowTrade)
{
   if ((CurTime()-LastTrade)<10) return (0);
   ticket=0;
   //   .
   while (ticket==0)
   {   
   RefreshRates();
   price = NormalizeDouble(Low[i]-(limit*Point),Digits);
   SL    = price + StopLoss   * Point;
   TP    = price - TakeProfit * Point;
   ticket=OrderSend(Symbol(), OP_SELLSTOP, Lots, price, 3, SL, TP, "OP_SELLSTOP", magicNumber, 0, SkyBlue);      
   Sleep(1000);
   }

   Sleep(10000);

   ticket=0;
   //   .
   while (ticket==0)
   {
   RefreshRates();
   SL = NormalizeDouble(Ask,Digits) - StopLoss   * Point;
   TP = NormalizeDouble(Ask,Digits) + TakeProfit * Point;
   ticket=OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),3,SL,TP,"OP_BUY",magicNumber,0,Yellow);
   Sleep(1000);
   }
   LastTrade=CurTime();
   OpenBuy=false;
}
//+------------------------------------------------------------------------------------------------+
//|                                             
//+------------------------------------------------------------------------------------------------+

   return(0);
}
//+------------------------------------------------------------------+